#include "data.h"

namespace Data {

// Data
vector<Model*>		_models;
int					_currModel = 0;
int					_currTime = 0;
QFont					_font = QFont("Arial",12);

// Inspectors

Model* currModel() { 
	if(_currModel < _models.size()) return _models[_currModel];	
	else return 0;
}

int currTime() {
	return _currTime;
}

QFont font() {
	return _font;
}

// Mutators

void insertModel(Model* m) { 
	m->analyze();
	_models.push_back(m);					
}

void clearModels() { 
	_models.clear(); 
	_currModel = 0;	
	_currTime = 0;
}

void setFont(QFont f) {
	_font = f;
}

void resetTime() {
	_currTime = 0;
}

bool nextTime() {
	if(currModel() && _currTime < currModel()->maxTime()) {
		_currTime++;
		return true;
	}
	return false;
}

bool prevTime() {
	if(currModel() && _currTime > 0) {
		_currTime--;
		return true;
	}
	return false;
}

}
