#include <iostream>
#include "error.h"

namespace Error {

int _nrerrors = 0;
int	nrerrors()		{ return _nrerrors;	}
void	clearerrors()	{ _nrerrors = 0;		}

/** Global error function **/

void error() {
	++_nrerrors;
	cerr << "ERROR: ";
}

void atom(const string& name, const vector<string>& args) {
	cerr << name << '(';
	if(!args.empty()) {
		cerr << args[0];
		for(int n = 1; n < args.size(); ++n) cerr << ',' << args[n];
	}
	cerr << ")";
}

/** Parsing errors **/

void int_expected(const string& name, const vector<string>& args, int pos) {
	error();
	cerr << "Integer expected at position " << pos << " of atom ";
	atom(name,args);
	cerr << ".\n";
}

void too_few_args(const string& name, const vector<string>& args) {
	error();
	cerr << "Too few arguments in atom "; 
	atom(name,args);
	cerr << ".\n";
}

}
