#include "shape.h"

/** Polynomials **/

PolyShape::PolyShape(vector<QPoint>& vq) {
	int refx = vq[0].rx();
	int refy = vq[0].ry();
	for(int n = 0; n < vq.size(); ++n) {
		_points.push_back(QPoint(vq[n].rx()-refx,vq[n].ry()-refy));
	}
}

int PolyShape::minx() {
	int res = 0;
	for(int n = 1; n < _points.size(); ++n) {
		int temp = _points[n].rx();
		res = ((temp < res) ? temp : res);
	}
	return res;
}

int PolyShape::miny() {
	int res = 0;
	for(int n = 1; n < _points.size(); ++n) {
		int temp = _points[n].ry();
		res = (temp < res) ? temp : res;
	}
	return res;
}

int PolyShape::maxx() {
	int res = 0;
	for(int n = 1; n < _points.size(); ++n) {
		int temp = _points[n].rx();
		res = ((temp > res) ? temp : res);
	}
	return res;
}

int PolyShape::maxy() {
	int res = 0;
	for(int n = 1; n < _points.size(); ++n) {
		int temp = _points[n].ry();
		res = (temp > res) ? temp : res;
	}
	return res;
}

QRect PolyShape::brect() {
	return QRect(minx(),miny(),maxx()-minx(),maxy()-miny());
}


/** Ellipse **/

QRect ElliShape::brect() {
	return QRect(0,0,_width,_height);
}
