# -*- coding: utf-8 -*-
import re
from bioasp.asp import *
from libsbml import *


def ReadSBMLnetwork_with_score(filename, name) :
   r = SBMLReader()
   f = r.readSBML(filename)
   m = f.getModel()
   lpfacts = TermSet()
   #compartments = m.getListOfCompartments()
   #compartment_id2name = {}
   #for comp in compartments:
   #compartment_id2name[comp.getId()]=ident(comp.getName())
   species =m.getListOfSpecies()
   for spec in species:
      #species_id2name[spec.getId()] = (spec.getName(), compartment[spec.getCompartment()])
      lpfacts.add(Term('species', ["\""+spec.getId()+"\""]))
      #XMLNode = spec.getAnnotation() 
      #if XMLNode :
        #child = XMLNode.getChild(1) 
        #metapath_id = child.getAttrValue("id") 
        #print str(metapath_id)
   list_reactions = m.getListOfReactions()
   numero = 0
   for react in list_reactions:
      Reaction_ID = react.getId()
      lpfacts.add(Term('reaction', ["\""+Reaction_ID+"\"", "\""+name+"\""]))

      XMLNode = react.getAnnotation() 
      if XMLNode :
        child = XMLNode.getChild(2) 
        value = child.getAttrValue("val") 
      else : value=""
      if value!="" :
          value = int(float(value)*1000)
          #print "value(\"",Reaction_ID,"\",",str(value),")"
          lpfacts.add(Term('value', ["\""+Reaction_ID+"\"", str(value)]))
      else : 
          #print " no value for ",Reaction_ID   
          lpfacts.add(Term('value', ["\""+Reaction_ID+"\"", "0"]))

#HINT : in our application(network expansion) reversible reactions are already encoded as two reactions
# but it's needed in general for metnet 2 influence graphs
      is_reversible=react.getReversible();
      if(is_reversible):
        lpfacts.add(Term('reversible', ["\""+Reaction_ID+"\""]))
        #print 'reversible:',Reaction_ID
        
      for source in react.getListOfReactants():
          lpfacts.add(Term('reactant', ["\""+source.getSpecies()+"\"", "\""+Reaction_ID+"\"","\""+name+"\""]))
      for cible in react.getListOfProducts():
          lpfacts.add(Term('product', ["\""+cible.getSpecies()+"\"", "\""+Reaction_ID+"\"","\""+name+"\""]))
   return lpfacts
   

def ReadSBMLnetwork(filename, name) :
   r = SBMLReader()
   f = r.readSBML(filename)
   m = f.getModel()
   lpfacts = TermSet()
   #compartments = m.getListOfCompartments()
   #compartment_id2name = {}
   #for comp in compartments:
   #compartment_id2name[comp.getId()]=ident(comp.getName())
   species =m.getListOfSpecies()
   for spec in species:
      #species_id2name[spec.getId()] = (spec.getName(), compartment[spec.getCompartment()])
      lpfacts.add(Term('species', ["\""+spec.getId()+"\""]))
      #XMLNode = spec.getAnnotation() 
      #if XMLNode :
        #child = XMLNode.getChild(1) 
        #metapath_id = child.getAttrValue("id") 
        #print str(metapath_id)
   list_reactions = m.getListOfReactions()
   numero = 0
   for react in list_reactions:
      Reaction_ID = react.getId()
      lpfacts.add(Term('reaction', ["\""+Reaction_ID+"\"", "\""+name+"\""]))

#HINT : in our application(network expansion) reversible reactions are already encoded as two reactions
# but it's needed in general for metnet 2 influence graphs
      is_reversible=react.getReversible();
      if(is_reversible):
        lpfacts.add(Term('reversible', ["\""+Reaction_ID+"\""]))
        #print 'reversible:',Reaction_ID
        
      for source in react.getListOfReactants():
          lpfacts.add(Term('reactant', ["\""+source.getSpecies()+"\"", "\""+Reaction_ID+"\"","\""+name+"\""]))
      for cible in react.getListOfProducts():
          lpfacts.add(Term('product', ["\""+cible.getSpecies()+"\"", "\""+Reaction_ID+"\"","\""+name+"\""]))
   return lpfacts


def ReadSBMLtargets(filename) :
   r = SBMLReader()
   f = r.readSBML(filename)
   m = f.getModel()
   lpfacts = TermSet()
   #compartments = m.getListOfCompartments()
   #compartment_id2name = {}
   #for comp in compartments:
   #compartment_id2name[comp.getId()]=ident(comp.getName())
   species =m.getListOfSpecies()
   for spec in species:
      #species_id2name[spec.getId()] = (spec.getName(), compartment[spec.getCompartment()])
      lpfacts.add(Term('target', ["\""+spec.getId()+"\""]))
   return lpfacts
   
   
def ReadSBMLseeds(filename) :
   r = SBMLReader()
   f = r.readSBML(filename)
   m = f.getModel()
   lpfacts = TermSet()
   #compartments = m.getListOfCompartments()
   #compartment_id2name = {}
   #for comp in compartments:
   #compartment_id2name[comp.getId()]=ident(comp.getName())
   species =m.getListOfSpecies()
   for spec in species:
      #species_id2name[spec.getId()] = (spec.getName(), compartment[spec.getCompartment()])
      lpfacts.add(Term('seed', ["\""+spec.getId()+"\""]))
   return lpfacts


                
